DirectMail.mf = DirectMail.mf || {};
var es = function (n, ord) {
  if (ord) return 'other';
  return (n == 1) ? 'one' : 'other';
};
var plural = function (value, offset, lcfunc, data, isOrdinal) {
  if ({}.hasOwnProperty.call(data, value)) return data[value];
  if (offset) value -= offset;
  var key = lcfunc(value, isOrdinal);
  if (key in data) return data[key];
  return data.other;
};
var fmt = {
  number: function (value, lc, arg
  /*``*/) {
  
    var a = arg && arg.split(':') || []
    var opt = {
      integer: { maximumFractionDigits: 0 },
      percent: { style: 'percent' },
      currency: {
        style: 'currency',
        currency: a[1] && a[1].trim() || "USD",
        minimumFractionDigits: 2,
        maximumFractionDigits: 2
      }
    }
    return new Intl.NumberFormat(lc, opt[a[0]] || {}).format(value)
  
  }
};

DirectMail.mf.HistorySummary = {
  SCHEDULE_DELIVERY: function(d) { return "Programar envío"; },
  RESCHEDULE_DELIVERY: function(d) { return "Reprogramar envío"; },
  CANCELLING: function(d) { return "Cancelando…"; },
  CANCEL_DELIVERY: function(d) { return "Cancelar envío"; },
  UPDATE_ERROR_DETAILS: function(d) { return "Se ha producido un error al actualizar este informe: " + d.error_description; },
  UPDATE_ERROR: function(d) { return "Se ha producido un error al actualizar este informe."; },
  POPOVER_BOUNCES: function(d) { return d.value + " devueltos (" + d.ratio + " de los destinatarios)"; },
  POPOVER_SPAM: function(d) { return d.value + " marcados como spam (" + d.ratio + " de los correos enviados)"; },
  POPOVER_UNSUBSCRIBES: function(d) { return d.value + " bajas (" + d.ratio + " de los correos enviados)"; },
  TOOLTIP_NUM_CLICKED_LINK: function(d) { return plural(d.num_clicked, 0, es, { one: "1 destinatario ha hecho clic en este enlace", other: fmt.number(d.num_clicked, "es", "integer") + " destinatarios han hecho clic en este enlace" }); },
  POPOVER_OPENS: function(d) { return d.number_opened + " aperturas (" + d.open_rate + " de los correos enviados, " + plural(d.number_of_views, 0, es, { one: "1 apertura en total", other: fmt.number(d.number_of_views, "es", "integer") + " aperturas en total" }) + ")"; },
  POPOVER_CLICKS: function(d) { return d.number_clicked + " clics (" + d.click_rate + " de los correos enviados, " + plural(d.number_of_clicks, 0, es, { one: "1 clic en total", other: fmt.number(d.number_of_clicks, "es", "integer") + " clics en total" }) + ")"; }
}
;
if ( fmt !== undefined ) {
    if ( window.DirectMail_nativeController !== undefined && window.DirectMail_nativeController.formatNumber !== undefined ) {
        fmt.number = function(v,lc,p) {
            return window.DirectMail_nativeController.formatNumber(v,p);
        };
    }
    else {
        var fmt_number = fmt.number;
        fmt.number = function(v,lc,p) {
            return fmt_number(v,navigator.language,p);
        };
    }
}
