package Email::MIME::RFC2047::Decoder;
our$VERSION='0.90';
use strict;
use Encode ();
use MIME::Base64 ();
my$rfc_specials='()<>\[\]:;\@\\,."';
my$rfc_specials_no_quote='()<>\[\]:;\@\\,.';
my$encoded_word_text_re=qr/
    (?: ^ | (?<= \s ) )
    = \? ( [\w-]+ ) \?
    (?:
        [Bb] \?
        (
            (?:
                [A-Za-z0-9+\/]{2}
                (?: == | [A-Za-z0-9+\/] [A-Za-z0-9+\/=] )
            )+
        ) |
        [Qq] \?
        ( [^?\x00-\x20\x7f-\x{ffff}]+ )
    )
    \? =
    (?= \z | \s )
/x;
my$encoded_word_phrase_re=qr/
    (?: ^ | (?<= [\s$rfc_specials_no_quote] ) )
    = \? ( [\w-]+ ) \?
    (?:
        [Bb] \?
        (
            (?:
                [A-Za-z0-9+\/]{2}
                (?: == | [A-Za-z0-9+\/] [A-Za-z0-9+\/=] )
            )+
        ) |
        [Qq] \?
        ( [^?\x00-\x20$rfc_specials\x7f-\x{ffff}]+ )
    )
    \? =
    (?= \z | [\s$rfc_specials_no_quote] )
/x;
my$quoted_string_re=qr/
    "
    (
        (?:
            [^"\\] |
            \\ .
        )*
    )
    "
/sx;
sub new{my$package=shift;
my$self={};
return bless($self,$package);}sub decode_text{my$self=shift;
return$self->_decode('text',@_);}sub decode_phrase{my$self=shift;
return$self->_decode('phrase',@_);}sub _decode{my($self,$mode,$encoded)=@_;
my$encoded_ref=ref($encoded)?$encoded:\$encoded;
my$result='';
my$enc_flag;
my$regex=$mode eq 'phrase'?qr/([^$rfc_specials]*?)($encoded_word_phrase_re|$quoted_string_re)/:qr/(.*?)($encoded_word_text_re)/s;
while($$encoded_ref=~/\G$regex/cg){my($text,$match,$encoding,$b_content,$q_content,$qs_content)=($1,$2,$3,$4,$5,$6,$7);
if(defined($encoding)){if(length($match)>255){$result.=$text;
$result.=$match;
$enc_flag=undef;
last;}my$content;
if(defined($b_content)){$content=MIME::Base64::decode_base64($b_content);}else{$content=$q_content;
$content=~tr/_/ /;
$content=~s/=([0-9A-Fa-f]{2})/chr(hex($1))/eg;}my$chunk;
eval{$chunk=Encode::decode($encoding,$content,Encode::FB_CROAK);};
if($@){warn($@);
$result.=$text;
$result.=$match;
$enc_flag=undef;
last;}$result.=$text if!$enc_flag||$text=~/\S/;
$result.=$chunk;
$enc_flag=1;}else{$result.=$text;
$result.=' ';
$qs_content=~s/\\(.)/$1/gs;
$result.=$qs_content;
$result.=' ';
$enc_flag=undef;}}$regex=$mode eq 'phrase'?qr/[^$rfc_specials]+/:qr/.+/s;
$result.=$&if$$encoded_ref=~/\G$regex/cg;
$result=~s/^\s+//;
$result=~s/\s+\z//;
$result=~s/\s+/ /g;
$result=~s/[\x00-\x1f\x7f]//g;
return$result;}1;
__END__


